import numpy as np
import seaborn as sns
import matplotlib.pyplot as plt


##########################################
##### Klasse Punkt #######################
##########################################
class Point:
    def __init__(self, x, y):
        self.__x = x # x-Koordinate
        self.__y = y # y-Koordinate

    def get_x(self):
        return self.__x

    def get_y(self):
        return self.__y


#########################################
##### Hilfsfunktion #####################
##### stellt die Datenpunkte ############
##### zur Verfügung #####################
#########################################
def create_and_append_points(points):
    points.append(Point(2.5, 3.3))
    points.append(Point(3.1, 3.1))
    points.append(Point(4.6, 3.8))
    points.append(Point(5.2, 3.9))
    points.append(Point(6, 3))
    points.append(Point(7, 3.1))
    points.append(Point(8, 3.5))

    points.append(Point(3.1, 4.1))
    points.append(Point(4.6, 4.8))
    points.append(Point(5.2, 4.9))
    points.append(Point(6, 4))
    points.append(Point(7, 4.1))

    points.append(Point(4.6, 5.8))
    points.append(Point(5.2, 5.9))
    points.append(Point(6, 5))

    points.append(Point(3.1, 6.1))
    points.append(Point(4.6, 6.8))
    points.append(Point(5.2, 6.9))
    points.append(Point(6, 6))
    points.append(Point(7, 6.1))

    points.append(Point(4.6, 7.8))
    points.append(Point(5.2, 7.9))
    points.append(Point(6, 7))

    points.append(Point(5, 8))

    points.append(Point(5, 1))
    points.append(Point(5, 2))
    points.append(Point(5.3, 1.2))
    points.append(Point(5.1, 2.4))
    # Am Ende der Funktion enthält die Liste points sämtliche Datenpunkte


# Generieren der Datenpunkte
points = []
create_and_append_points(points) # Befüllen der Liste points mit den Datenpunkten

#Aufgabe Schüler -- Beginn

# Die Schüler bekommen den Befehl data = np.zeros((2, 2)) vorgelegt
# und müssen diesen geeignet modifizieren
data = np.zeros((10, 10)) # Legt Matrix der Größe 10x10 an

# Die nachfolgenden Zeilen fehlen bei den Schülern und sind
# zu vervollständigen
for point in points: # for-Schleife über die Datenpunkte
    # Wichtig: Rumpf der for-Schleife muss in Python eingerückt werden!
    data[int(point.get_x())][int(point.get_y())] += 1 # Abrunden durch die Funktion int und inkrementieren

#Aufgabe Schüler -- Ende

# Formatieren und Zeichnen der Heatmap
data = np.swapaxes(data, 0, 1) # Transponieren der Matrix
sns.set()
sns.heatmap(data, cmap = "YlOrRd") # Erstellen der Heatmap mit vorgegebenem Farbschema YlOrRd
plt.gca().invert_yaxis() # y-Achse des Plots spiegeln
plt.show() # Grafik anzeigen